﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@

#Event: Message(LogMsg As String)

#IgnoreWarnings: 9

Sub Class_Globals
	Dim mWebView1 As WebView
'	Dim Console As WebView ' We can use another WebView as JS console ...
'                           If someone want contribute, this is a suitable way to extend the console
'                           functionalities, even use CSS to style, trap errors and show eg. in red
'                           color, place labels and more

'	Dim btnToggleConsole As Button
'	Dim WVX As WebViewExtras  ' We can integrate other libraries like UltimateWebView or WebViewExtras to extend functionalities
	
	Dim mTextConsole As EditText ' ... or just an EditText, Label etc ... you have a console string
	Dim mLabelConsole As Label
	
	Private mParent As Panel
	Private mModule As Object
	Private mEventName As String
	Private mHeight As Float
	
'	Dim sb As StringBuilder
'	Dim somecss As String
	
	Dim mLogActive As Boolean = True
	Dim mDuration As Int = 1000
End Sub

'Inizialize the JSConsole object.
Public Sub Initialize(Parent As Panel, Module As Object, EventName As String, WebView As WebView, Height As Float)
	mParent = Parent
	mModule = Module
	mEventName = EventName.ToLowerCase
	mHeight = Height
	
	mWebView1 = WebView
	mWebView1.Initialize("mWV1")
'	Console.Initialize("Console") ' Use a WebView ...
	
'  We can use StringBuilder to fast collect JS log
'	sb.Initialize
	
	'  Some code to style a console webview
'	somecss = "<meta name='viewport' content='width=device-width, initial-scale=1.0, user-scalable=no'>" _
'	          & "<style type='text/css'>body{background:yellow;}</style>"
	
'	mParent.AddView(Console, 0, 100%y-Height, 100%x, Height)
	
'	WVX.addJavascriptInterface(WebView1, "B4A")
'	WVX.addWebChromeClient(webview, "ChromeClient")
	
	' ////////// ADD A CUSTOM CHROME CLIENT TO A WEBVIEW ///////////
	
	Log (Me)
	Log(Application.PackageName & ".jsconsole$MyChromeClient")
	
	Dim cxt As JavaObject
	cxt.InitializeContext
	Dim customchromeclient As JavaObject = Me  ' Aggiunto = Me
	customchromeclient.InitializeNewInstance(Application.PackageName & ".jsconsole$MyChromeClient", Array(cxt, mWebView1, "CustomChromeClient"))
	
	' ... or use a TextField, Label etc ...
	mTextConsole.Initialize("TextConsole")
	mTextConsole.TextSize = 10
	mTextConsole.Typeface = Typeface.SANS_SERIF
	mTextConsole.Color = Colors.DarkGray
	mTextConsole.TextColor = Colors.Green
	mTextConsole.Gravity = Gravity.LEFT + Gravity.TOP
	mTextConsole.Padding = Array As Int (3dip, 23dip, 3dip, 3dip)
	mTextConsole.Text = "Ready" & CRLF & CRLF
	mParent.AddView(mTextConsole, 0, 100%y-Height, 100%x, Height)
	
	mLabelConsole.Initialize("LabelConsole")
	mLabelConsole.TextSize = 12
	mLabelConsole.Typeface = Typeface.DEFAULT_BOLD
	mLabelConsole.Color = Colors.Blue
	mLabelConsole.TextColor = Colors.LightGray
	mLabelConsole.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL
	mLabelConsole.Padding = Array As Int (1dip, 1dip, 1dip, 1dip)
	mLabelConsole.Text = "JS CONSOLE"
	mParent.AddView(mLabelConsole, 0, 100%y-Height, 100%x, 20dip)
	
'	btnToggleConsole.Initialize("btnToggleConsole")  ' We just click on a label or longclick on a edittext
'	btnToggleConsole.Text = "C"
'	mParent.AddView(btnToggleConsole, 100%x-60dip, 64%y-60dip, 50dip, 50dip)
   
	HideConsole(0)
End Sub

'Sub Console_PageFinished (Url As String)
'	Log("Console: Page finished: " & Url)
'	WVX.pageDown(console, True)  ' Scroll the page. Not super, sometime fails
'End Sub

Sub WV1_PageFinished (Url As String)
	Log("Page finished: " & Url)
End Sub

'Sub btnToggleConsole_Click
'	If mLogActive Then HideConsole(mDuration) Else ShowConsole(mDuration)
'End Sub

Sub LabelConsole_Click
	If mLogActive Then HideConsole(mDuration) Else ShowConsole(mDuration)
End Sub

'Show a console with layout animation.
'Duration:  The animation duration in milliseconds. Pass 0 for no animation.
Sub ShowConsole (Duration As Int)
	mDuration = Duration ' Store for future uses
	mTextConsole.SetLayoutAnimated(mDuration, 0, 100%y-mHeight, 100%x, mHeight)
	mLabelConsole.SetLayoutAnimated(mDuration, 0, 64%y, 100%x, 20dip)
	mLogActive = True
End Sub

'Hide a console with layout animation.
'Duration:  The animation duration in milliseconds. Pass 0 for no animation.
Sub HideConsole(Duration As Int)
	mDuration = Duration ' Store for future uses
	mTextConsole.SetLayoutAnimated(mDuration, 0, 100%y, 100%x, mHeight)
	mLabelConsole.SetLayoutAnimated(mDuration, 0, 100%y, 100%x, 20dip)
	mLogActive = False
End Sub

''Return the console WebView control.
''This way you can customize it.
'Sub getConsole As WebView
'	Return Console
'End Sub

'Return the console EditText control.
'This way you can customize it.
Sub getConsole As EditText
	Return mTextConsole
End Sub

'Return the console label. 
'This way you can customize it.
Sub getLabel As EditText
	Return mLabelConsole
End Sub

Private Sub CustomChromeClient_Console(Msg As String)
	' We can show the JS log in a new webview ...
'	sb.Append(LogMsg).Append("<br>")
'	Console.LoadHtml(somecss & sb.ToString)
	
	' ... or in a TextField, Label etc ...
	mTextConsole.Text = mTextConsole.Text & Msg & CRLF
	mTextConsole.SetSelection(mTextConsole.Text.Length-2, 1) ' AutoScroll
	ShowConsole(mDuration) ' Automatically show a console on log messages
	
'	' ... or just on the Log
'	Log(Msg)  ' Optionally we can redirect JS console to B4A console
''	               (Note that we used our custom message, see Java code)

'	If SubExists(mModule, mEventName & "_message") Then
'		CallSub2(mModule, mEventName & "_message", Msg)
'	End If
End Sub

#if Java
   import anywheresoftware.b4a.BA;
   import anywheresoftware.b4a.keywords.Common;
   import android.content.Context;
	
   import android.webkit.WebView;
   import android.webkit.WebChromeClient;
   import android.webkit.WebResourceRequest;
   import android.webkit.WebResourceResponse;   
   import android.webkit.ConsoleMessage;

	public static class MyChromeClient extends WebChromeClient {
		Context context;
		WebView webview;
		String fullEventName;
	   	  
	  public MyChromeClient(Context c, WebView w, String event) {  // aggiunto BA ba
			this.context = c;
			this.webview = w;
			this.fullEventName = event.toLowerCase(BA.cul) + "_console";

			w.setWebChromeClient(new WebChromeClient() {
            @Override 
            public boolean onConsoleMessage (ConsoleMessage consoleMessage) {
               String logMessage = "JS LOG: " + consoleMessage.message() + 
					"    -    (" + consoleMessage.sourceId() + " @ Line: " + consoleMessage.lineNumber() + ")";
					
  					Common.Log(logMessage);  // <<<<<<< Redirect JS Log to B4A Log (You can do it here or in B4A Sub Event)
  
               //if (Common.subExists(fullEventName)) 
					   //processBA.raiseEventFromUI(this, fullEventName, new Object[] {logMessage});	
					//ba.raiseEventFromUI(this, EventName.toLowerCase(BA.cul) + "_fire", 10);
              
				  return true;
             }
	     });
      }
		
    }
#End if